/*!
 * Copyright 2012 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
import JSBI from "jsbi";
export declare class JsbiSupport {
    static readonly ZERO: JSBI;
    static readonly ONE: JSBI;
    static readonly TWO: JSBI;
    static readonly NUMBER_MAX_SAFE_INTEGER: JSBI;
    static readonly NUMBER_MIN_SAFE_INTEGER: JSBI;
    static isZero(value: JSBI): boolean;
    static isNegative(value: JSBI): boolean;
    static bigIntFromString(text: string): JSBI;
    static clampToSafeIntegerRange(value: JSBI): number;
    static isSafeInteger(value: JSBI): boolean;
}
