/*!
 * Copyright 2012 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
import { Import } from "./IonImport";
export declare class LocalSymbolTable {
    private readonly _import;
    private readonly offset;
    private index;
    constructor(theImport: Import | null, symbols?: (string | null)[]);
    private _symbols;
    get symbols(): (string | null)[];
    get maxId(): number;
    get import(): Import;
    getSymbolId(symbol_: string): number;
    addSymbol(symbol_: string | null): number;
    private assignSymbolId;
    getSymbolText(symbolId: number): string | null;
    numberOfSymbols(): number;
}
export declare function defaultLocalSymbolTable(): LocalSymbolTable;
