/*!
 * Copyright 2012 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
import { Import } from "./IonImport";
import { SharedSymbolTable } from "./IonSharedSymbolTable";
const systemSymbolTable = new SharedSymbolTable("$ion", 1, [
    "$ion",
    "$ion_1_0",
    "$ion_symbol_table",
    "name",
    "version",
    "imports",
    "symbols",
    "max_id",
    "$ion_shared_symbol_table",
]);
export function getSystemSymbolTable() {
    return systemSymbolTable;
}
export function getSystemSymbolTableImport() {
    return new Import(null, getSystemSymbolTable());
}
//# sourceMappingURL=IonSystemSymbolTable.js.map